//PrintCSV1.java

//TEST ENVIRONMENT
//CPU:     intel Core i3-1005G1
//MEMORY:  8GB
//STRAGE:  117GB SSD
//DISPLAY: 1920~1080 px (setup 150%: 1280~720 px)
//OS:      Windows11 Home
//JDK:     JDK18
//u^XN o[IɉBvɐݒ

//ȂAʓIȃfBXvC̉𑜓x́Aȉ̒ʂB
//8Ki7680~4320 dotj
//4Ki3840~2160j
//WQHDi2560~1440j
//FHDi1920~1080j
//WXGA++(1600~900j
//HDi1280~720j
//A
//FHDi1920~1080jőł莖̕WłB

//PROJECT
//CSVt@Cr̕\ɉHĈB

/*
DIRECTORIES & FILES
/user/java/PrintCSV1/src@@\[XEt@CEfBNg[
    PrintCSV1.java
    PrintCSV1MenuLis.java
    PrintCSV1ButtonLis.java
    PrintCSV1AnalyzeEngine.java
    PrintCSV1CanvasEngine.java
    PrintCSV1PrintEngine.java
    PrintCSV1FileIO.java

/user/java/Lib/src@@@@@Cu[E\[XEt@CEfBNg[
    SystemMessage.java
    StackTraceMonitor.java
    Util.java
    SingleFileFilter.java
    TextIO.java

/user/java/PrintCSV1/sys@@@VXeEt@CEfBNg[
    PrintCSV1Manual.txt

/user/java/PrintCSV1/pcc@@@`fBNg[(gqpcc)
/user/java/PrintCSV1/data @@f[^fBNg[(gqcsv, txt)

/user/class@@@@@@@@@NXEt@CEfBNg[(gqclass)
*/

//C|[g
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;
import java.awt.geom.*;
import java.awt.print.*;

//t[`
class PrintCSV1 extends JFrame implements SystemMessage
{
    //o[ϐ

    //{Iȕϐ
    PrintCSV1 f;
    static PrintCSV1 sf;
    Container pane;
    PrintCSV1CanvasEngine canvas;  //摜`搧
    PrintCSV1AnalyzeEngine analyze; //ߕ
    PrintCSV1PrintEngine printer;  //
    PrintCSV1MenuLis menuLis;      //j[EXi[
    PrintCSV1ButtonLis buttonLis;  //{^EXi[
    PrintCSV1FileIO io;            //o͍
    JMenuBar menuBar;              //j[zu
    JPanel buttonBar1 = new JPanel(); //{^zu
    JPanel buttonBar2 = new JPanel(); //{^zu
    JPanel buttonBar3 = new JPanel(); //{^zu
    JLabel dataFile     = new JLabel("  [NoName]"); //t@C
    JLabel controlFile  = new JLabel("  [NoName]"); //t@C
    JLabel scaleLabel   = new JLabel("  (scale: )"); //\XP[
    JLabel pageNumLabel = new JLabel("  (page:  )"); //Yy[W
    JLabel pixelLabel   = new JLabel("  (pixel: )"); //摜sNZ
    JLabel mmLabel      = new JLabel("  (mm: )");    //TCY
    JTextArea  dArea, cArea, mArea;
    JScrollPane scroll0,scroll1,scroll2,scroll3;
    final int scroll0Width;
    final int scroll1Width;
    final int scroll2Width;
    final int scroll0Height;
    final int scroll3Height;

    //ʕ\Ɖ摜ۑƂɔf}`{B
    //~Pʂ₷sNZPʂɒu邪A
    //ɂ͔fȂB
    final double xL6 = 6.0;
    final double xL5 = 5.0;
    final double xL4 = 4.0;
    final double xL3 = 3.0; //1 mm  3 pxisNZjŕ\iWݒj
    final double xL2 = 2.0;
    final double xL1 = 1.0;
    
    int cdLines;
    int cdCols;
    int mLines;
    int mCols;
    
    //Gg[|Cg
    public static void main(String[] args)
    {
        //ʍ\z̐
        new PrintCSV1(null, null);
    }

    //t[̃RXgN^
    PrintCSV1(final SystemMessage sm, final StackTraceMonitor st)
    {
        super("PrintCSV1  Ver.1.0");
        f = this;
        sf = this;

        //vO̊JnƏI
        if(st != null) //TuVXeƂĎsȂ
        {
            addWindowListener(new WindowAdapter()
            {
                public void windowClosing(WindowEvent e) //Ƃ
                {
                    st.setFrame(sm); //eVXeSystemMessageɖ߂
                }
                public void windowActivated(WindowEvent e) //ANeBu
                {
                    st.setFrame(f); //SystemMessageɐؑւ
                }
            });
            st.setFrame(this); //ŏ́ASystemMessageɐؑւ
            setDefaultCloseOperation(DISPOSE_ON_CLOSE); //TuVXêݏI
        }
        else //PƎsȂA
        {
            new StackTraceMonitor(this).start(); //WG[o͂̊Ď
            setDefaultCloseOperation(EXIT_ON_CLOSE);  //SI
        }

        //XEBOŕ\镶s傫B
        //ꂼ̎sɍ킹Đl𒲐邱ƁB
        //L̐lݒ́AȈՐݒB
        if(getToolkit().getScreenSize().width >= 1280 &&
           getToolkit().getScreenSize().height >= 720)
        {
            cdLines = 30;
            cdCols  = 26;
            mLines  =  4;
            mCols   = 100;
        }
        else
        {
            cdLines = 20;
            cdCols  = 17;
            mLines  =  3;
            mCols   = 66;
        }

        //v蕔̐
        menuLis  = new PrintCSV1MenuLis(this);
        buttonLis = new PrintCSV1ButtonLis(this);

        //v@\̐
        canvas   = new PrintCSV1CanvasEngine(this);
        analyze  = new PrintCSV1AnalyzeEngine(this);
        printer  = new PrintCSV1PrintEngine(this);
        io       = new PrintCSV1FileIO(this);

        //MENU BAR:j[\i
        JMenu menu;
        setJMenuBar(menuBar = new JMenuBar());

        addA(menuBar, menu = new JMenu("t@C"));
        addB(menu, new JMenuItem("f[^JiUTF-8j"),  menuLis, "Lo8");
        addB(menu, new JMenuItem("f[^ۑiUTF-8j"),  menuLis, "Sa8");
        menu.addSeparator();
        addB(menu, new JMenuItem("JiUTF-8j"), menuLis,  "LoD");
        addB(menu, new JMenuItem("ۑiUTF-8j"), menuLis,  "SaD");
        menu.addSeparator();
        addB(menu, new JMenuItem("摜"),   menuLis,     "Pri");

        addA(menuBar, menu = new JMenu(""));
        addB(menu, new JMenuItem("f[^"), menuLis,   "Cl1");
        addB(menu, new JMenuItem(""), menuLis,     "Cl2");
        addB(menu, new JMenuItem("x"), menuLis,     "Cl3");
        addB(menu, new JMenuItem("S"), menuLis,         "Cl4");

        addA(menuBar, menu = new JMenu("{"));
        addB(menu, new JMenuItem("CSV rWp@"), menuLis, "Std");
        addB(menu, new JMenuItem("CSV rp@"), menuLis, "Spe");
        addB(menu, new JMenuItem("NUL e̐"), menuLis, "Nam");
        addB(menu, new JMenuItem("NUL A4"), menuLis,   "TA4");
        addB(menu, new JMenuItem("NUL J[h"), menuLis,   "PCd");
        addB(menu, new JMenuItem("NUL tHgEeXg1"), menuLis, "Pht");
        addB(menu, new JMenuItem("NUL tHgEeXg2"), menuLis, "Ph2");

        addA(menuBar, menu = new JMenu("\"));
        addB(menu, new JMenuItem("\:x6"),    menuLis,     "XL6");
        addB(menu, new JMenuItem("\:x5"),    menuLis,     "XL5");
        addB(menu, new JMenuItem("\:x4"),    menuLis,     "XL4");
        addB(menu, new JMenuItem("\:x3 Wݒ"), menuLis, "XL3");
        addB(menu, new JMenuItem("\:x2"),    menuLis,     "XL2");
        addB(menu, new JMenuItem("\:x1"),    menuLis,     "XL1");
        
        addA(menuBar, menu = new JMenu("wv"));
        addB(menu, new JMenuItem("gp@"),     menuLis,     "Usa");

        menuBar.add(new JLabel("@@@"));
        menuBar.add(dataFile);
        menuBar.add(controlFile);
        menuBar.add(new JLabel("@@@"));
        menuBar.add(scaleLabel);
        menuBar.add(pageNumLabel);
        menuBar.add(new JLabel("@@@"));
        menuBar.add(pixelLabel);
        menuBar.add(mmLabel);

        //BUTTON BAR:{^\i
        buttonBar1.setLayout(new FlowLayout(FlowLayout.LEFT));
        buttonBar2.setLayout(new FlowLayout(FlowLayout.LEFT));
        buttonBar3.setLayout(new FlowLayout(FlowLayout.LEFT));

        addB(buttonBar1, new JButton("폜P"),
            new ActionListener()
            { public void actionPerformed(ActionEvent event)
                { dArea.cut(); } } ,"");

        addB(buttonBar1, new JButton("ʂP"),
            new ActionListener()
            { public void actionPerformed(ActionEvent event)
                { dArea.copy(); } } ,"");

        addB(buttonBar1, new JButton("}P"),
            new ActionListener()
            { public void actionPerformed(ActionEvent event)
                { dArea.paste(); } } ,"");
        
        addB(buttonBar2, new JButton("폜Q"),
            new ActionListener()
            { public void actionPerformed(ActionEvent event)
                { cArea.cut(); } } ,"");

        addB(buttonBar2, new JButton("ʂQ"),
            new ActionListener()
            { public void actionPerformed(ActionEvent event)
                { cArea.copy(); } } ,"");

        addB(buttonBar2, new JButton("}Q"),
            new ActionListener()
            { public void actionPerformed(ActionEvent event)
                { cArea.paste(); } } ,"");

        addB(buttonBar3, new JButton("`"), buttonLis, "Dsp");
        addB(buttonBar3, new JButton(""), buttonLis, "Top");
        addB(buttonBar3, new JButton("O"), buttonLis, "Prv");
        addB(buttonBar3, new JButton(""), buttonLis, "Nex");

        //DATA AREA:f[^\i
        dArea = new JTextArea(cdLines,cdCols);
        dArea.setBackground(new Color(230,230,255));
        dArea.setMargin(new Insets(3, 3, 3, 3)); //]    
        scroll0 = new JScrollPane(
            dArea,
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

        //CONTROL AREA:`\i
        cArea = new JTextArea(cdLines,cdCols);
        cArea.setBackground(new Color(230,230,255));
        cArea.setMargin(new Insets(3, 3, 3, 3)); //]    
        scroll1 = new JScrollPane(
            cArea,
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

        //GRAPHIC AREA:}\摜\i
        scroll2 = new JScrollPane(
            canvas,
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        scroll2.setPreferredSize(new Dimension(
            (int)scroll0.getPreferredSize().getWidth() + 
            (int)scroll1.getPreferredSize().getWidth(),
            (int)scroll0.getPreferredSize().getHeight()));
        canvas.setPreferredSize(new Dimension(3000,3000));
        canvas.setOpaque(true); //s
        
        //bZ[W\i
        mArea = new JTextArea(mLines,mCols);
        mArea.setBackground(new Color(230,230,255));
        mArea.setMargin(new Insets(3, 3, 3, 3)); //]    
        scroll3 = new JScrollPane(
            mArea,
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        mArea.setAutoscrolls(true);  //XN[
        mArea.setEditable(false);  //ҏW֎~

        //S̃CAEg
        //{bNXECAEg𗘗p
        pane = getContentPane();
        Box vBox = Box.createVerticalBox();
        Box vBox1 = Box.createVerticalBox();
        Box vBox2 = Box.createVerticalBox();
        Box vBox3 = Box.createVerticalBox();
        Box hBox = Box.createHorizontalBox();
        pane.add(vBox);
        vBox.add(hBox);
        hBox.add(vBox1);
        hBox.add(vBox2);
        hBox.add(vBox3);
        vBox1.add(buttonBar1);
        vBox2.add(buttonBar2);
        vBox3.add(buttonBar3);
        vBox1.add(scroll0);
        vBox2.add(scroll1);
        vBox3.add(scroll2);
        vBox.add(scroll3);

        //̑̏
        scroll0Width =  (int)scroll0.getPreferredSize().getWidth();
        scroll1Width =  (int)scroll1.getPreferredSize().getWidth();
        scroll2Width =  (int)scroll2.getPreferredSize().getWidth();
        scroll0Height = (int)scroll0.getPreferredSize().getHeight();
        scroll3Height = (int)scroll3.getPreferredSize().getHeight();
        pack();
        setVisible(true);
        
        GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
        int screenW = gd.getDisplayMode().getWidth();
        int screenH = gd.getDisplayMode().getHeight();
        message("hardware screen size = " + screenW + " ~ " + screenH + " px");
        //LXN[ETCÝAn[hEFAƂĂ̖{̐lB

        screenW = getToolkit().getScreenSize().width;
        screenH = getToolkit().getScreenSize().height;
        message("software screen size = " + screenW + " ~ " + screenH + " px");
        //LXN[ETCÝAOSŃZbgAbvꂽ\tgEFAł̐lB
    }
    
    //Rei[ JMenu CAEg
    public void addA(Container cont, AbstractButton b)
    {
        cont.add(b);
    }
    //Rei[ JButton or JMenuItem CAEg
    public void addB(Container cont, AbstractButton b,
        ActionListener lis, String command)
    {
        cont.add(b);
        if(lis!=null)
            b.addActionListener(lis);
        if(command!=null)
            b.setActionCommand(command);
    }

    //VXebZ[W̕\
    public void message(String s)
    {  //G[̒ʒmA܂͏󋵂̕
        int len = mArea.getText().length();
        mArea.select(len, len); //XN[
        mArea.append(s + "\n");
    }

    //JFrame̕ĕ`vɂ͑Sʍĕ`
    public void repaint(int x, int y, int w, int h)
    { //󂯎l𖳎AS̒lɒu
        super.repaint(0,0,getWidth(),getHeight());
    }
}
