//PrintCSV1CanvasEngine.java

//C|[g
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.util.List;
import java.text.*;
import java.awt.geom.*;
import java.io.*;
import java.awt.image.*;
import java.util.regex.*;
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import javax.imageio.IIOImage;
import javax.imageio.ImageWriter;
import javax.imageio.ImageWriteParam;
import javax.imageio.stream.ImageOutputStream;

//ȑ`悷B
//̑Ag@\
class PrintCSV1CanvasEngine extends JLabel
{
    //o[ϐ
    PrintCSV1 f;
    private int page = 0; //݃y[WL
    Graphics2D g2;

    //`֘A̕ϐ
    double paperW;    //(mm)
    double paperH;    //
    double marginT;   //] Top
    double marginL;   // Left
    double pHeaderH;  //y[Wo
    double tHeaderH;  //\o
    double cellH;     //Z (mm)
    int    shiftClass;//Vtg敪
    double shiftX;    //VtgX
    double shiftY;    //VtgY

    double affineScale  = 1.0; //\{
    double freeScale    = 1.0; //ǉ{
    double affineDegree = 0.0; //90x]px
    boolean rotateFlag  = false;//90x][h
    boolean antialiasFlag = true;//̗֊s̃MUMUɘa

    int fontSize;     //TCY(point)
    boolean fontBold; //̑w
    float lineWidth;
    String title;     //W
    String subtitle;  //W
    String number;    //sԍ
    boolean pageNumFlag; //y[Wԍ̗L
    String footnote;  //r
    String footnote2;  //r2
    boolean dataFlag; //f[^p邩ۂ
    String loadData;  //f[^t@C
    double colW[];    //J(mm)
    String align[];   //lAElAl`w
    String header[];  //\o
    int cols;         //Ps̑    i0NZj
    int rows;         //Py[W̑si0NZj
    int rowBlock;     //s̃ubN
    int drawMode;     //\gr̕`惂[h
    double[][] lineArr;     //R
    double[][] stringArrD;  //R
    String[][] stringArrS;
    String[]   colBlockArr;  //JEZp[^[
    Color backgroundColor;
    Color foregroundColor;
    float quality = 1.0f; //掿ۑiftHgj
        //掿́AOPwłiPō掿j
    double currentPointX;
    double currentPointY;

    //CSVf[^֘A̕ϐ
    int pages;    //y[W      i0NZj
    int lines;    //s          i0NZj
    int colCnt;   //JE^[  i0NZj
    int rowCnt;   //sJE^[  i0NZj
    int pageCnt;  //y[WJE^[i0NZj
    int lineCnt;  //sJE^[i0NZj
    String dataArray[][][]; //y[WEsE
    boolean dataInspection; //f[^
    boolean grpSaveMode; //trueȂ摜ۑ[h
    String dataType = "NUL";
    String[] manualArr = null;
    String errMsg;    //G[bZ[W

    //Xg֘A̕ϐ
    List<double[]> lineList      = new ArrayList<double[]>();
    List<double[]> stringDataListD   = new ArrayList<double[]>();
    List<String[]> stringDataListS   = new ArrayList<String[]>();
    List<double[]> freeStringListD    = new ArrayList<double[]>();
    List<String[]> freeStringListS    = new ArrayList<String[]>();
    List<double[]> freeStringListBD    = new ArrayList<double[]>();
    List<String[]> freeStringListBS    = new ArrayList<String[]>();
    List<String> columnList     = new ArrayList<String>();
    List<String> columnLineList = new ArrayList<String>();

    //RXgN^
    PrintCSV1CanvasEngine(PrintCSV1 frame)
    {
        f = frame;
        affineScale = f.xL3; //g嗦ݒ
        f.scaleLabel.setText("  (scale:x3)"); //\g嗦ݒ
        manualArr = TextIO.loadStrArr(
          new File("c:/user/java/PrintCSV1/sys/PrintCSV1Manual.txt"));
    }

    //`ǎAeϐZbg
    void setDef(String str)
    { //OvO瑀
        f.cArea.setText(str);
        setDef();
    }

    void setDef()
    { //vO瑀
        //ϐ̏
        paperW       = 362; //`͈͏ݒ
        paperH       = 512; //`͈͏ݒ
        freeScale    = 1.0; //ɔfg{
        fontSize     = 10;
        fontBold     = false;
        antialiasFlag = true;
        lineWidth    = 0.2f;
        marginT      = 0;
        marginL      = 0;
        pHeaderH     = 0; //page header
        tHeaderH     = 0; //table header
        cellH        = 0;
        shiftClass   = 0;
        shiftX       = 0;
        shiftY       = 0;
        colCnt       = 0;
        rowBlock     = 1;
        drawMode     = 3; //r`惂[h
        title        = "";
        subtitle     = "";
        number       = "";
        footnote     = "";
        footnote2     = "";
        errMsg       = "";
        loadData     = "";
        dataType     = "NUL"; //CSV, NUL
        pageNumFlag  = false;
        dataFlag     = true;
        rotateFlag   = false;
        colBlockArr  = null;
        backgroundColor = Color.white;
        foregroundColor = Color.black;

        String define     = ""; //`̂Psi[
        lineList          = new ArrayList<double[]>();
        stringDataListD   = new ArrayList<double[]>();
        stringDataListS   = new ArrayList<String[]>();
        freeStringListD   = new ArrayList<double[]>();
        freeStringListS   = new ArrayList<String[]>();
        freeStringListBD  = new ArrayList<double[]>();
        freeStringListBS  = new ArrayList<String[]>();
        columnList        = new ArrayList<String>();
        columnLineList    = new ArrayList<String>();

        //------------------------------------------------------------
        // ߕSs̉
        f.analyze.commandAnalyze(f.cArea.getText());
        //------------------------------------------------------------

        // l̎擾
        Object[] lineArr0 = lineList.toArray();
        lineArr  = new double[lineArr0.length][4];
        for(int i=0; i<lineArr0.length; i++)
        {
            lineArr[i][0] = ((double[])(lineArr0[i]))[0];
            lineArr[i][1] = ((double[])(lineArr0[i]))[1];
            lineArr[i][2] = ((double[])(lineArr0[i]))[2];
            lineArr[i][3] = ((double[])(lineArr0[i]))[3];
        }

        //Rj@f[^̎擾
        Object[] stringArrD0 = freeStringListD.toArray();
        Object[] stringArrS0 = freeStringListS.toArray();
        stringArrD = new double[stringArrD0.length][3];
        stringArrS = new String[stringArrS0.length][2];
        for(int i=0; i<stringArrD0.length; i++)
        {
            stringArrD[i][0] = ((double[])(stringArrD0[i]))[0];
            stringArrD[i][1] = ((double[])(stringArrD0[i]))[1];
            stringArrD[i][2] = ((double[])(stringArrD0[i]))[2];
        }
        for(int i=0; i<stringArrD0.length; i++)
        {
            stringArrS[i][0] = ((String[])(stringArrS0[i]))[0];
            stringArrS[i][1] = ((String[])(stringArrS0[i]))[1];
        }

        if(dataFlag==false && loadData.equals(""))
        {  //f[^pȂwł
            setData(" "); //f[^AXy[X
        }
        else if(dataFlag==false && !loadData.equals(""))
        {  //f[^pȂ̂Ƀt@C̎w肪
            dataInspection = false;  //`~X
            errMsg += ("Data  LoadData Ƃɖ\n");
            return;
        }
        else if(dataFlag==true && loadData.equals(""))
        {  //f[^t@CȂł
            ; //ݕ\Ăf[^p
        }
        else if(dataFlag==true && !loadData.equals(""))
        {  //f[^t@C̎w肪
            String line = null;
            String line2 = "";
            BufferedReader reader = null;
            try
            {  //f[^t@Cǂݍ
                reader = new BufferedReader(new FileReader(loadData));
                try
                {
                    String [] rowData;
                    for(int i=0;;i++) //f[^ǎ
                    {
                        line =  reader.readLine();
                        if(line == null) //I[zȂ
                            break;
                        else
                            line2 = line2 + line + "\n";
                    }
                }
                catch(IOException e)
                {
                    f.message("ǎG[>>\n" +e);
                }
                reader.close();
            }
            catch(FileNotFoundException e)
            {
                f.message("I[vG[>>\n"+e);
            }
            catch(IOException e)
            {
                f.message("N[YG[>>\n"+e);
            }
            setData(line2);
        }
    } //setDef()

    //f[^f[^GAǎAeϐZbg
    void setData(String str) //OvO瑀
    {
        f.dArea.setText(str);
        setData();
    }

    //vO瑀
    void setData()
    { 
        String data = f.dArea.getText();
        StringTokenizer st1 = new StringTokenizer(data,"\n"); 
          //s͕pō폜
        //y[WvZ svZ
        String dataP = "";
        for(rowCnt=0,pageCnt=0,lineCnt=0; 
            st1.hasMoreTokens(); rowCnt++,lineCnt++)
        {
            String str = st1.nextToken();
            
            if(rowCnt>=rows)
            { //Py[W
                pageCnt++;
                rowCnt = -1; //ōsJEg -1 
            }
            dataP = dataP + str +"\n";
        }
        data = dataP;
        if(rowCnt==0)
            pageCnt--;
        pages = pageCnt;
        lines = --lineCnt; //s

        //f[^̎Oz(y[WEsE)
        dataArray = new String[pages+1][rows+1][];
        st1 = new StringTokenizer(data,"\n");
        for(pageCnt=0,rowCnt=0,lineCnt=0; lineCnt<=lines;)
        {
            String record = st1.nextToken();
            String c[] = null;
            if(!record.equals("\n"))
            {
                if(dataType.equals("CSV"))
                    c = Util.csv2Array(record.trim(),cols+1);
                else if(dataType.equals("NUL"))
                    c = new String[] {""};
                else
                    c = new String[] {record}; //ꉞA
                if(c==null)
                {
                    if(cols==0)
                        return;
                    errMsg += ("f[^ڐُF"+(rowCnt+1)+"s\n");
                    dataInspection = false;
                    return;
                }
            }
            else
            {
                errMsg += ("f[^sF"+(rowCnt+1)+"s\n");
                dataInspection = false;
                return;
            }
            dataArray[pageCnt][rowCnt] = c;
            rowCnt++;
            lineCnt++;
            if(rowCnt>rows) //Py[W
            {
                pageCnt++;  //y[WJEg
                rowCnt=0;   //sJEgZbg
            }
        }
    } //setData()

    //擪y[Wɐݒ
    void firstPage()
    {
        page = 0; //0NZ
    }

    //Oy[W
    void prevPage()
    {
        if(page > 0)
            page--;
        else
            page = pages;
    }

    //y[W
    void nextPage()
    {
        if(page < pages)
            page++;
        else
            page = 0;
    }

    //`ƃf[^̃`FbN
    boolean check()
    {
        dataInspection = true;
        setDef();
        setData();
        if(dataInspection == false) 
        {  //`f[^Ɍ肪
            f.message(errMsg);
            return false;
        }
        else
            return true;
    }

    //`揈
    public void paintComponent(Graphics g)
    {
        drawPage(g, false, page);
    }

    //Py[W̕`
    void drawPage(Graphics g, boolean printMode, int page)
    {
        g2 = (Graphics2D)g;

        //`̏Ή
        g2.setColor(new Color(255,127,255)); //摜`͈͊OiW΁j
        g2.fill(new Rectangle2D.Double(
            0,0,f.canvas.getPreferredSize().width,
            f.canvas.getPreferredSize().height));
        g2.setColor(new Color(127,255,255)); //摜`͈͊OiW΁j
        g2.fill(new Rectangle2D.Double(0,0,3000,3000));

        if(!check())
            return;
        g2.scale(affineScale*freeScale, affineScale*freeScale); //g
        if(rotateFlag) //90x]
        {
            g2.translate(paperH, 0); //ړ
            affineDegree = 90; //90x]w
            g2.rotate(affineDegree*Math.PI/180.0);
            //W_𒆐Sɉ]iw菇Ӂj
        }
        if(antialiasFlag == true) //̃MUMUɘa
          //ׂ̐FA͂Ƃ̒ԐFŁAɔȂ
          g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
        else
          g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_OFF);

        //tHgTCY̒vZij
        int fSize;
        fSize = (int)(fontSize/3.0); //W\{R{̂߁A傫𒲐
        Font fontL, fontM;
        if(fontBold == false)
        {
            fontL = new Font(Font.SANS_SERIF,Font.PLAIN,
                (int)(fSize*1.2));
            fontM = new Font(Font.SANS_SERIF,Font.PLAIN,
                fSize);
        }
        else
        {
            fontL = new Font(Font.SANS_SERIF,Font.BOLD,
                (int)(fSize*1.2));
            fontM = new Font(Font.SANS_SERIF,Font.BOLD,
                fSize);
        }

        //ʌ_̌vZ
        double innerX0 = marginL;
        double innerY0 = marginT;

        //VtgL̈ʌ_̌vZ
        if( (shiftClass==1) || //Vtg
            (shiftClass==2 && (page%2 ==1))) 
        {  //y[WVtg;  page:0NZ
            innerX0 = marginL + shiftX;
            innerY0 = marginT + shiftY;
        }
        else if(shiftClass==2 && (page%2 ==0)) 
        {  //y[WVtg;  page:0NZ
            innerX0 = marginL;
            innerY0 = marginT;
        }

        //VtǧvZ
        double sX = 0;
        double sY = 0;
        if( (shiftClass==1) ||  
            (shiftClass==2 && (page%2 ==1)) )
        {  //Vtg܂͏Vtgy[W
            sX = shiftX;
            sY = shiftY;
        }
        else if(
            (shiftClass==2 && (page%2 ==0)) )
        {  //Vtg܂͏Vtgy[W
            sX = 0;
            sY = 0;
        }
        
        //r\e̐@擾
        double cellW[] = new double[cols+1];
        for(int i=0; i<colW.length; i++)
            cellW[i] = colW[i];
        double innerW = 0;  //ʕ
        for(int i=0; i<cellW.length; i++)
            innerW += cellW[i];

        //r\̕\ʒǔvZ
        FontMetrics fm = g2.getFontMetrics(fontL);
        double titleX = innerX0 + (innerW - fm.stringWidth(title))/2;
        double titleY;
        double titleH = fm.getAscent();
        if(!title.trim().equals(""))
            titleY  = innerY0 + titleH;
        else
            titleY  = innerY0;

        //sԍisNjʒǔvZ
        fm = g2.getFontMetrics(fontM);
        double numberX  = innerX0 + (innerW - fm.stringWidth(number));
        double numberY;
        if(pageNumFlag==true)
            numberY  = innerY0 + pHeaderH -fm.getAscent()*1.7;
        else
            numberY  = innerY0 + pHeaderH -fm.getAscent()*0.7;

        //y[WԍʒǔvZ
        double pageNumberX = innerX0 + (innerW - fm.stringWidth(
            "page # " + (page+1) + "/" + (pages+1)));
        double pageNumberY = innerY0 + pHeaderH -fm.getAscent()*0.5;
        f.pageNumLabel.setText("  (page:" + (page+1) + "/" + (pages+1)+")");

        //r\W̌vZ
        double tHeaderY = innerY0+ pHeaderH;
        double gridY = tHeaderY + tHeaderH; 
            //gridƂ́Ar\̌ogiq̃f[^LB
        double gridW = 0.0;
        for(int i=0; i<cellW.length; i++)
            gridW += cellW[i];
        double gridH = cellH*(rows+1);
        
        //rʒǔvZ
        fm = g2.getFontMetrics(fontM);
        double footnoteX  = innerX0;
        double footnoteY  = tHeaderY + tHeaderH + gridH + fm.getAscent()*1.5;

        //r2ʒǔvZ
        fm = g2.getFontMetrics(fontM);
        double footnote2X  = innerX0;
        double footnote2Y  = footnoteY + fm.getAscent()*1.5;

        //̕`揀
        BasicStroke solidLine = new BasicStroke( //̒`
            lineWidth, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_MITER);
        BasicStroke dotLine = new BasicStroke( //_̒`
            lineWidth, BasicStroke.CAP_SQUARE, 
            BasicStroke.JOIN_MITER, 1f, new float[] {1f,1f}, 0f);
        g2.setStroke(solidLine); //ɐݒ

        g2.setPaint(backgroundColor); //wiF
        g2.fill(new Rectangle2D.Double(0,0,paperW,paperH));
        g2.setColor(foregroundColor);

        //------------------------------------------------------------

        //r`
        if(drawMode==3 || drawMode==2)
        {
            g2.draw(new Line2D.Double(
                innerX0, tHeaderY, innerX0+gridW, tHeaderY));
            for(int i=0; i<=(rows+1); i++)
            {
                if((i)%rowBlock == 0)
                    g2.draw(new Line2D.Double(
                        innerX0, gridY+cellH*i, 
                        innerX0+gridW, gridY+cellH*i));
                else
                {
                    float dot[] = {0.4f,0.4f};
                    g2.setStroke(dotLine); //_
                    g2.draw(new Line2D.Double(
                        innerX0, gridY+cellH*i, 
                        innerX0+gridW, gridY+cellH*i));
                    g2.setStroke(solidLine); //
                }
            }
        }
        //crAwb_[`
        g2.setFont(fontM);
        fm = g2.getFontMetrics(fontM);
        double sumW=0;
        g2.setStroke(solidLine); //
        for(int i=0; i<(cols+1); i++)
        {
            if(i>=1 && colBlockArr != null) //c̋敪
            {
                if(colBlockArr[i-1].equals("0"))
                    g2.setStroke(dotLine); //_
                else
                    g2.setStroke(solidLine); //
            }
            if(drawMode==3 || drawMode==1)
                g2.draw(new Line2D.Double(
                    innerX0+sumW, tHeaderY, innerX0+sumW, gridY+gridH));
            if(tHeaderH>0)
            {
                String header2[] = Util.csv2Array(header[i], 0, '/');
                g2.drawString(header2[0],
                    (float)(innerX0+sumW+(cellW[i] - 
                        fm.stringWidth(header2[0]))/2),
                    (float)(tHeaderY+fm.getAscent()+cellH*0.2D));
                if(header2.length==2)
                    g2.drawString(header2[1],
                        (float)(innerX0+sumW+(cellW[i] - 
                            fm.stringWidth(header2[1]))/2),
                        (float)(tHeaderY+fm.getAscent()*2+cellH*0.2D));
            }
            sumW += cellW[i];
        } //for
        g2.setStroke(solidLine);
        if(drawMode==3 || drawMode==1)  //c̍Ō̈{
            g2.draw(new Line2D.Double(
                innerX0+sumW, tHeaderY, 
                innerX0+sumW, gridY+gridH));

        //f[^`irɏރf[^j
        sumW=0;
        for(rowCnt=0; page*(rows+1)+rowCnt<=lines && rowCnt<=rows && 
            dataType.equals("CSV"); rowCnt++)
        {
            for(colCnt=0; colCnt<=cols; colCnt++)
            {
                //f[^EtB[h̎擾
                String field = null;
                try
                {
                    field = dataArray[page][rowCnt][colCnt];
                    if(field == null)
                    {
                        f.message("f[^̍ŏIsz");
                        return;
                    }
                }
                catch(IndexOutOfBoundsException e)
                {
                    f.message("f[^z̋Ez");
                    return;
                }
                g2.setColor(Color.black);
                //̈ʒu킹
                double strMargin = fm.getAscent()*0.5;
                if(align[colCnt].equals("L"))
                { //̍lߕ\
                    g2.drawString(field,
                        (float)(innerX0+sumW+strMargin),
                        (float)(tHeaderY+tHeaderH+cellH*(rowCnt+1)
                            -strMargin));
                }
                else if(align[colCnt].equals("R"))
                { //̉Elߕ\
                    g2.drawString(field,
                        (float)(innerX0+sumW+cellW[colCnt]
                            -fm.stringWidth(field)-strMargin),
                        (float)(tHeaderY+tHeaderH+cellH*(rowCnt+1)
                            -strMargin));
                }
                else if(align[colCnt].charAt(0)=='N')
                { //lɃR}tA𐮌`
                  //N0,N1,N3,N4Ȃǂ̌`ŁAw肵đ
                  //ȂuN0vw肷
                    try
                    {
                        int fraction = 
                            (int)(align[colCnt].charAt(1))-(int)'0';
                        field = Util.decimalStringFormat(field, fraction);
                    }
                    catch(NumberFormatException e)
                    {
                        f.message("l`G[F"+field);
                        return;
                    }
                    g2.drawString(field,
                        (float)(innerX0+sumW+cellW[colCnt]
                        -fm.stringWidth(field)-strMargin),
                        (float)(tHeaderY+tHeaderH+cellH*(rowCnt+1)
                        -strMargin));
                }
                sumW += cellW[colCnt];
            }// for
            sumW=0;
        }// for

        g2.setColor(Color.black);
        //WAy[WAL̕`
        g2.setFont(fontL);
        g2.drawString(title,(float)titleX,(float)(titleY+1.0)); 
            //1.0͒[؏グ
        g2.setFont(fontM);
        g2.drawString(subtitle,(float)innerX0,(float)pageNumberY);
        g2.drawString(number,(float)numberX,(float)numberY);
        if(pageNumFlag==true)
            g2.drawString("page # " + Integer.toString(page+1) + 
                "/" + (pages+1),
                (float)pageNumberX, (float)pageNumberY);
        g2.setFont(fontM);
        g2.drawString(footnote, (float)footnoteX, (float)footnoteY);
        g2.drawString(footnote2, (float)footnote2X, (float)footnote2Y);

        //-----------------------------------------------------------------

        //̕`
        for(int i=0; i<lineArr.length; i++)
        {
            g2.draw(new Line2D.Double(
                lineArr[i][0]+sX,lineArr[i][1]+sY,
                lineArr[i][2]+sX,lineArr[i][3]+sY));
        }
        //vr[̏ꍇ`L͈͘g\
        if(printMode==false && grpSaveMode==false)
        { 
            g2.setColor(Color.red);
            int z = (int)(paperW/20);
            g2.draw(new Line2D.Double(paperW/4, paperH, paperW/2+paperW/4, paperH));
            g2.draw(new Line2D.Double(paperW, paperH/4, paperW, paperH/2+paperH/4));
            g2.draw(new Line2D.Double(paperW, paperH/2, paperW+z, paperH/2-z));
            g2.draw(new Line2D.Double(paperW, paperH/2, paperW+z, paperH/2+z));
            g2.draw(new Line2D.Double(paperW/2, paperH, paperW/2-z, paperH+z));
            g2.draw(new Line2D.Double(paperW/2, paperH, paperW/2+z, paperH+z));
            g2.draw(new Line2D.Double(paperW+5, paperH, paperW*1.5, paperH));
            g2.draw(new Line2D.Double(paperW, paperH+5, paperW, paperH*1.5));
            g2.setColor(Color.black);
        }

        //R̕`
        g2.setColor(foregroundColor);
        for(int i=0; i<stringArrD.length; i++)
        { 
            //`͊ei"sansserif" / "serif" / "monospaced" ....j
            Font fontT = new Font(stringArrS[i][0],Font.PLAIN,
            (int)(stringArrD[i][2]/3.0)); //W\{R{̂߁ATCY
            if(fontBold==true)
            {
              fontT = new Font(stringArrS[i][0],Font.BOLD,
              (int)(stringArrD[i][2]/3.0)); //W\{R{̂߁ATCY
            }
            g2.setFont(fontT);
            g2.drawString(
                stringArrS[i][1],(float)(stringArrD[i][0]+sX),
                (float)(stringArrD[i][1]+sY));
        }

        //sNZƃ~ƂAj[Eo[ɕ\
        int pw = ((int)(paperW*affineScale*freeScale)); 
            //pw : pixel؂o͈͂̋
        int ph = ((int)(paperH*affineScale*freeScale)); 
            //ph : pixel؂o͈͂̏
        f.pixelLabel.setText("  ("+pw+"x"+ ph+"px)");
        f.mmLabel.setText("  ("+(int)(paperW*freeScale)+"x"+
            (int)(paperH*freeScale)+"mm)");
    } //draw()

    //摜
    void eraseGraph()
    {
        f.canvas.g2.setPaint(new Color(126,126,126));
        f.canvas.g2.fill(new Rectangle2D.Double(
            0,0,f.canvas.getPreferredSize().width,
            f.canvas.getPreferredSize().height));
            f.canvas.g2.setPaint(new Color(255,5,255));
        f.canvas.g2.fillRect(0,0,3500,3500);
        f.canvas.g2.drawString("摜", (float)10, (float)10);
        f.message("摜");
    }

    //G[Ǝv郁\bh̋Lq`擾Čx
    void methodErrorMessage(String s)
    {
        for(int i= 0; i<manualArr.length; i++)
        {
            if(manualArr[i].trim().startsWith("" + s))
                f.message("qgF"+manualArr[i].trim());
        }
    }
}
