//PrintCSV1FileIO.java

//C|[g
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import java.util.*;
import java.util.regex.*;

//JMenuItem̃CxgXi[
class PrintCSV1FileIO
{
    //o[ϐ
    PrintCSV1 f;

    //RXgN^
    PrintCSV1FileIO(PrintCSV1 frame)
    {
        f = frame;
    }

    //t@CǂݍށiftHgR[hj
    void load(JTextArea tArea, String dir, String ext)
    {
        JFileChooser fileChooser = new JFileChooser(dir);
        if(!ext.equals("*"))
        {
            SingleFileFilter filter = new SingleFileFilter(ext);
            fileChooser.setFileFilter(filter);
        }
        int ret = fileChooser.showOpenDialog(f.pane);
        File file = fileChooser.getSelectedFile();
        if(ret != JFileChooser.APPROVE_OPTION || file == null)
        {
            return;
        }
        try
        {

            FileReader reader = new FileReader(file);
            try
            {
                tArea.read(reader,new PlainDocument());
            }
            catch(IOException e)
            {
                f.message("[hG[F"+e);
            }
            reader.close();
        }
        catch(FileNotFoundException e)
        {
            f.message("I[vG[F"+e);
        }
        catch(IOException e)
        {
            f.message("N[YG[F"+e);
        }
    }

    //t@CɏށiftHgR[hj
    void save(JTextArea tArea, String dir, String ext)
    {
        JFileChooser fileChooser = new JFileChooser(dir);
        if(!ext.equals("*"))
        {
            SingleFileFilter filter = new SingleFileFilter(ext);
            fileChooser.setFileFilter(filter);
        }
        int ret = fileChooser.showSaveDialog(f.pane);
        File file = fileChooser.getSelectedFile();
        if(ret != JFileChooser.APPROVE_OPTION || file == null)
        {
            return;
        }
        try
        {
            FileWriter writer = new FileWriter(file);
            try
            {
                String str = tArea.getText();
                if(str.equals(""))
                    f.message("`܂̓f[^Ȃ");
                else
                    writer.write(str);
            }
            catch(IOException e)
            {
                f.message("CgG[F"+e);
            }
            writer.close();
            f.message(file.getName()+" ݂܂B");
        }
        catch(FileNotFoundException e)
        {
            f.message("I[vG[F"+e);
        }
        catch(IOException e)
        {
            f.message("N[YG[F"+e);
        }
    }

    //t@CǂݍށiUTF-16/UTF-8R[hj
    void loadUTF(JTextArea tArea, String dir, String ext, String utf)
    {
        JFileChooser fileChooser = new JFileChooser(dir);
        if(!ext.equals("*"))
        {
            SingleFileFilter filter = new SingleFileFilter(ext);
            fileChooser.setFileFilter(filter);
        }
        int ret = fileChooser.showOpenDialog(f.pane);
        File file = fileChooser.getSelectedFile();
        if(ret != JFileChooser.APPROVE_OPTION || file == null)
        {
            return;
        }
        tArea.setText(TextIO.loadText(file, utf));
        if(file.getName().endsWith(".pcc"))
            f.controlFile.setText("  [" + file.getName() + "]");
        else
            f.dataFile.setText("  [" + file.getName() + "]");
    }

    //t@CǂݍށiUTF-16/UTF-8R[hj
    void saveUTF(JTextArea tArea, String dir, String ext, String utf)
    {
        JFileChooser fileChooser = new JFileChooser(dir);
        if(!ext.equals("*"))
        {
            SingleFileFilter filter = new SingleFileFilter(ext);
            fileChooser.setFileFilter(filter);
        }
        int ret = fileChooser.showSaveDialog(f.pane);
        File file = fileChooser.getSelectedFile();
        if(ret != JFileChooser.APPROVE_OPTION || file == null)
        {
            return;
        }
        TextIO.saveText(file, tArea.getText(), utf);
    }
}
