//MakeCSV1.java
//[p CSV f[^쐬iϏAȂǁj
//\́ATuEVXeiPrintCSV1ǰĂяoɂčsȂ

//TEST ENVIRONMENT
//CPU:     intel Core i3-1005G1
//MEMORY:  8GB
//STRAGE:  117GB SSD
//DISPLAY: 1920~1080 px (setup 150%: 1280~720 px)
//OS:      Windows11 Home
//JDK:     JDK18
//u^XN o[IɉBvɐݒ

//ȂAʓIȃfBXvC̉𑜓x́Aȉ̒ʂB
//8Ki7680~4320 dotj
//4Ki3840~2160j
//WQHDi2560~1440j
//FHDi1920~1080j
//WXGA++(1600~900j
//HDi1280~720j
//A
//FHDi1920~1080jőł莖̕WłB
//OS̃ZbgAbvŁA\tgEFẢ𑜓xigkxjςB

/* display image
+----------------------------------------------------------------+
|   TITLE BAR        ivOzuj                      |
+----------------------------------------------------------------+
|   MENU  BAR        ij[zuj                          |
+----------------------------------------------------------------+
|   TOOL  BAR        i{^zuj                            |
+----------------------------------------------------------------+
|   TABLE PANEL      iזڃe[uzuj                      |
|                                                                |
|                                                                |
| - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  |
|                    ive[uzuj                      |
|                                                                |
+----------------------------------------------------------------+
|   INPUT PANEL-1    ieLXgEtB[hzuj              |
+----------------------------------------------------------------+
|   INPUT PANEL-2    ieLXgEtB[hzuj              |
+----------------------------------------------------------------+
|   INPUT PANEL-3    ieLXgEtB[hzuj              |
+----------------------------------------------------------------+
|   MESSAGE PANEL    ieLXgEGAzuj                  |
+----------------------------------------------------------------+
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;
import java.util.*;
import java.io.*;

//t[`
public class MakeCSV1 extends JFrame implements SystemMessage
{
    //o[ϐ
    MakeCSV1 f;
    StackTraceMonitor st;
    Container pane;
    MakeCSV1DataBase db;
    MakeCSV1MenuLis menuLis;
    MakeCSV1ToolLis toolLis;
    MakeCSV1InputLis inputLis;

    JPanel   tablePanel, inputPanel1, inputPanel2, inputPanel3, messagePanel;
    JMenuBar menuBar;
    JToolBar toolBar;
    JTable   table, table2;
    JTextField customerCode, customerName, customerRate, date;
    JTextField itemCode, itemName, basePrice, realRate, unitPrice, quantity, 
        sumPrice, taxRate, taxedPrice;
    DefaultTableModel tModel, tModel2;
    JTextArea  messageArea;

    int t1Width; //זڕ\(px)
    int t1Height;
    int t2Width; //v\(px)
    int t2Height;
    int mLines; //bZ[Wisj
    int mCols; //bZ[Wij
        
    File dataFile = null;
    File idFile = null;
    File formFile = null;
    final String dataExt = "csv"; //f[^t@C̊gqiWݒj
    final String formExt = "pcc"; //PrintCSV1`t@C̊gq
    final String manual = "./sys/MakeCSV1Manual.txt"; //gp@}jA
    static String printDir;

    //Gg[|Cg
    public static void main(String args[])
    {
        if(args.length==1)
            printDir = args[0];
        else
            printDir = ".";
        //ʍ\z̐
        new MakeCSV1();
    }

    //RXgN^
    MakeCSV1()
    {
        super("MakeCSV1  Ver.1.0");
        pane = getContentPane();
        f = this;
        (st = new StackTraceMonitor(this)).start(); 
          //X^bNg[X̕\bZ[WEGAɕύXB
          //X^bNg[XWG[o͂̂܂܂ɂꍇA
          //̈sRgɂĖɂB

        //ŗL@\̐
        db = new MakeCSV1DataBase(this);

        //vM̐iXi[j
        menuLis = new MakeCSV1MenuLis(this);
        toolLis = new MakeCSV1ToolLis(this);
        inputLis = new MakeCSV1InputLis(this);

        //vO̊JnƏI
        addWindowListener(new WindowAdapter()
        {
            public void windowActivated(WindowEvent e)
            { //t[̃ANeBu
            }
        });
        setDefaultCloseOperation(EXIT_ON_CLOSE);

        //XEBOŕ\镶s傫B
        //ꂼ̎sɍ킹Đl𒲐邱ƁB
        //L̐lݒ́AȈՐݒB
        if(getToolkit().getScreenSize().width >= 1280 &&
           getToolkit().getScreenSize().height >= 720)
        {
            t1Width = 1230; //זڕ\(px)
            t1Height = 330;
            t2Width = 1230; //v\(px)
            t2Height = 20;
            mLines = 5; //bZ[Wisj
            mCols = 136; //bZ[Wij
         }
         else
         {
            t1Width = 800; //זڕ\(px)
            t1Height = 220;
            t2Width = 800; //v\(px)
            t2Height = 20;
            mLines = 4; //bZ[Wisj
            mCols = 88; //bZ[Wij
         }

        //S̃CAEg
        setJMenuBar(menuBar = new JMenuBar());
        pane = getContentPane();
        Box box1 = Box.createVerticalBox(); //{bNXECAEg
        pane.add(box1);
        box1.add(toolBar     = new JToolBar());
        box1.add(tablePanel  = new JPanel());
        box1.add(inputPanel1 = new JPanel());
        box1.add(inputPanel2 = new JPanel());
        box1.add(inputPanel3 = new JPanel());
        box1.add(messagePanel= new JPanel());

        //MENU BAR ̃CAEg
        JMenu menu;
        addA(menuBar, menu = new JMenu("t@C"));
        addB(menu, new JMenuItem("J"), menuLis, "Load");
        addB(menu, new JMenuItem("ۑ"), menuLis, "Save");
        addB(menu, new JMenuItem(""), menuLis, "Print");
        addA(menuBar, menu = new JMenu(""));
        addB(menu, new JMenuItem("x"), menuLis, "Erase");
        addA(menuBar, menu = new JMenu("wv"));
        addB(menu, new JMenuItem("gp@"), menuLis, "Usage");

        //TOOL BAR ̃CAEg
        //JTable sPʂŕҏW{^̔zu
        toolBar.setFloatable(false);            //c[o[̈ʒuŒ
        toolBar.setBackground(new Color(255,255,100));    //wiFF
        toolBar.setLayout(new FlowLayout(FlowLayout.CENTER));//
        toolBar.setMaximumSize(new Dimension(Short.MAX_VALUE, 10));
        addB(toolBar, new JButton("I"), toolLis, "clearSelection");
        addB(toolBar, new JButton("Ss폜"), toolLis, "clear");
        addB(toolBar, new JButton("s폜"), toolLis, "cut");
        addB(toolBar, new JButton("sL"), toolLis, "copy");
        addB(toolBar, new JButton("s}"), toolLis, "paste");
        addB(toolBar, new JButton("sǉ"), toolLis, "append");
        addB(toolBar, new JButton("vZ"), toolLis, "verify");

        //TABLE PANEL ̃CAEg
        //iڒǉL^\
        tablePanel.setBackground(new Color(255,255,150));

        String headerName[] =   //e[ǔo
            {"i","i","P","","z","ŗ","ō"};
        tModel = new DefaultTableModel(headerName, 0); //f[^i[
        table = new JTable();   //e[u
        table.setModel(tModel); //f[^i[IuWFNg̐ݒ
        table.setRowHeight(20); //s̍ pixel
        table.setPreferredScrollableViewportSize(
            new Dimension(t1Width,t1Height)); //\͈ pixel
        table.setAutoscrolls(true);  //XN[w

        DefaultTableColumnModel cModel =  //S̃JǗ擾
            (DefaultTableColumnModel)table.getColumnModel();
        for(int i=0; i<7; i++) //SJɑ΂
        {
            TableColumn col = cModel.getColumn(i); //ʃJǗ
            col.setCellRenderer(new Ren(this)); //Jɕ\@w
        }
        JTableHeader header = table.getTableHeader(); //wb_Ǘ
        header.setResizingAllowed(true);   //JЂ̕ύX
        header.setReorderingAllowed(false); //J̕ύXs
        JScrollPane scroll = new JScrollPane(
            table,
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

        //vL^\
        String headerName2[] =   //e[ǔo
            {"","","","","vz","","ōz"};
        tModel2 = new DefaultTableModel(headerName2, 0); //f[^i[
        table2 = new JTable();   //e[u
        table2.setModel(tModel2); //f[^i[IuWFNg̐ݒ
        table2.setRowHeight(20); //s̍ pixcel
        table2.setPreferredScrollableViewportSize(
            new Dimension(t2Width,t2Height)); //\͈pixel
        table.setAutoscrolls(false);  //

        DefaultTableColumnModel cModel2 =  //S̃JǗIuWFNg擾
            (DefaultTableColumnModel)table2.getColumnModel();
        for(int i=0; i<7; i++) //SJɑ΂
        {
            TableColumn col = cModel2.getColumn(i); //ʃJǗ
            col.setCellRenderer(new Ren(this)); //Jɕ\@w
        }
        JTableHeader header2 = table2.getTableHeader(); //wb_Ǘ
        header2.setResizingAllowed(true);   //JЂ̕ύX
        header2.setReorderingAllowed(false); //J̕ύXs
        JScrollPane scroll2 = new JScrollPane(
            table2,
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);

        Box box2 = Box.createVerticalBox(); //{bNXECAEg
        tablePanel.add(box2);
        box2.add(scroll);
        box2.add(scroll2);

        String data[] =
            {"Total","","","","","","",""};
        tModel2.addRow(data);

        //INPUT PANEL-1 ̃CAEg
        inputPanel1.setBackground(new Color(100,255,255));
        Box box3 = Box.createHorizontalBox(); //{bNXECAEg
        inputPanel1.add(box3);

        box3.add(new JLabel("R[h"));
        box3.add(customerCode = new JTextField(10));
        customerCode.addActionListener(inputLis);
        customerCode.setActionCommand("cCode");
        Util.kanjiIn(customerCode, false); //ϊȂ

        box3.add(new JLabel("@於"));
        box3.add(customerName = new JTextField(25));
        customerName.addActionListener(inputLis);
        customerName.setActionCommand("cName");
        Util.kanjiIn(customerName, true); //ϊ[h

        box3.add(new JLabel("@|"));
        box3.add(customerRate = new JTextField(10));
        customerRate.addActionListener(inputLis);
        customerRate.setActionCommand("cRate");
        Util.kanjiIn(customerRate, false); //ϊȂ

        box3.add(new JLabel("@N"));
        box3.add(date = new JTextField(15));
        date.addActionListener(inputLis);
        date.setActionCommand("date");
        Util.kanjiIn(date, false); //ϊȂ

        //INPUT PANEL-2 ̃CAEg
        //iP̓́iOj
        inputPanel2.setBackground(new Color(150,255,255));
        Box box4 = Box.createHorizontalBox(); //{bNXECAEg
        inputPanel2.add(box4);

        box4.add(new JLabel("i"));
        addC(box4, itemCode = new JTextField(10), inputLis, "iCode");
        Util.kanjiIn(itemCode, false); //ϊȂ

        box4.add(new JLabel("@i"));
        addC(box4, itemName = new JTextField(25), inputLis, "iName");
        Util.kanjiIn(itemName, true); //ϊ[h

        box4.add(new JLabel("@艿"));
        addC(box4, basePrice = new JTextField(10), inputLis, "bPrice");
        Util.kanjiIn(basePrice, false); //ϊȂ

        box4.add(new JLabel("@ŗ"));
        addC(box4, taxRate = new JTextField(5), inputLis, "tRate");
        Util.kanjiIn(taxRate, false); //ϊȂ

        //INPUT PANEL-3 ̃CAEg
        //iP̓́i㔼j
        inputPanel3.setBackground(new Color(200,255,255));
        Box box5 = Box.createHorizontalBox(); //{bNXECAEg
        inputPanel3.add(box5);

        box5.add(new JLabel("@|"));
        addC(box5, realRate = new JTextField(5), inputLis, "rRate");
        Util.kanjiIn(realRate, false); //ϊȂ

        box5.add(new JLabel("@P"));
        addC(box5, unitPrice = new JTextField(10), inputLis, "uPrice");
        Util.kanjiIn(unitPrice, false); //ϊȂ

        box5.add(new JLabel("@"));
        addC(box5, quantity = new JTextField(10), inputLis, "quantity");
        Util.kanjiIn(quantity, false); //ϊȂ

        box5.add(new JLabel("@z"));
        addC(box5, sumPrice = new JTextField(15), inputLis, "sPrice");
        Util.kanjiIn(sumPrice, false); //ϊȂ

        box5.add(new JLabel("@ōz"));
        addC(box5, taxedPrice = new JTextField(15), inputLis, "tPrice");
        Util.kanjiIn(taxedPrice, false); //ϊȂ

        //MESSAGE PANEL ̃CAEg
        messageArea = new JTextArea(mLines,mCols);
        messageArea.setBackground(new Color(230,230,255));
        messageArea.setMargin(new Insets(3, 3, 3, 3)); //]    
        JScrollPane scroll3 = new JScrollPane(
            messageArea,
            JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
            JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        messageArea.setAutoscrolls(true);
        messageArea.setEditable(false); //ҏW֎~
        messagePanel.add(scroll3);
        messagePanel.setBackground(new Color(255,150,150));

        //̑̏
        pack();
        setVisible(true);
        customerCode.requestFocus();

        GraphicsDevice gd = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
        int screenW = gd.getDisplayMode().getWidth();
        int screenH = gd.getDisplayMode().getHeight();
        message("hardware screen size = " + screenW + " ~ " + screenH + " px");
        //LXN[ETCÝAn[hEFAƂĂ̖{̐lB

        screenW = getToolkit().getScreenSize().width;
        screenH = getToolkit().getScreenSize().height;
        message("software screen size = " + screenW + " ~ " + screenH + " px");
        //LXN[ETCÝAOSŃZbgAbvꂽ\tgEFAł̐lB
    }

    //VXebZ[W̕\
    public void message(String s)
    {
        int len = messageArea.getText().length();
        messageArea.select(len, len); //XN[s
        messageArea.append(s + "\n");
    }

    //Rei[ JMenu zu
    public void addA(Container cont, AbstractButton b)
    {
        cont.add(b);
    }
    //Rei[ JButton, JMenuItem zu
    public void addB(Container cont, AbstractButton b,
        ActionListener lis, String command)
    {
        cont.add(b);
        if(lis!=null)
            b.addActionListener(lis);
        if(command!=null)
            b.setActionCommand(command);
    }
    //CAEgE{bNX JTextField zu
    public void addC(Box box, JTextField field,
        ActionListener lis, String command)
    {
        box.add(field);
        if(lis!=null)
            field.addActionListener(lis);
        if(command!=null)
            field.setActionCommand(command);
    }

    //JTable ̕\`ύX
    class Ren extends DefaultTableCellRenderer
    { //̃X[p[NX JLabel
        MakeCSV1 f = null;
        Ren(MakeCSV1 frame)
        {
            f = frame;
        }
        //Z񂪕\邽тɌĂяo郁\bh
        public Component getTableCellRendererComponent(
            JTable table, Object value, boolean isSelected,
            boolean hasFocus, int row, int col)
        {
            setValue(value);        //Zɕ\
            if(isSelected && (table==f.table))
                setBackground(Color.lightGray); //ZIsȂO[
            else
                setBackground(Color.white);     //ȊO͔
            if(col>=2 && col<=6)
                setHorizontalAlignment(RIGHT);  //lJ͉E
            else
                setHorizontalAlignment(LEFT);   //͍̑
            return this; //ύX\IuWFNgigJLabeljԂ
        }
    }
}
