//PrintCSV1AnalyzeEngine.java

//C|[g
import java.awt.*;  //K{
import java.util.*;  //K{
import java.io.*;  //K{

//`@\̎
class PrintCSV1AnalyzeEngine
{
  //o[ϐ
  PrintCSV1 f; //JFlaměpCX^X
  PrintCSV1CanvasEngine canvas;
  Graphics2D g2;

  //RXgN^
  PrintCSV1AnalyzeEngine(PrintCSV1 flame)
  {
    f = flame;
    canvas = f.canvas;
  }

  void commandAnalyze(String commandZ)
  {
    //ߕ̑S
    //߂̈̂╴킵̂Ã`FbNsȂB
    boolean commentFlag = false;
    StringTokenizer st1 = new StringTokenizer(commandZ,";\n"); 
      //ߑSɑ΂āAZ~RƉsR[hŐ؂蕪鏀
    String method = ""; //܂܂Ȃߖ{̕
    String define = ""; //s̒`i܂ޖߕj

    //`̉
    try
    {
        for(int i=0; st1.hasMoreTokens(); i++)
        { //R}h̑S
            define = st1.nextToken().trim(); //s̒`
            if(define.equals(""))
                continue;
            if(define.substring(0,2).equals("//")) //Rg
                continue;
            StringTokenizer st2 = new StringTokenizer(define,"(,)");
            //
            method = st2.nextToken().trim();
    
            //R}h͎̉{
            if(method.equals("Antialias"))
            { //i֊s܂ށj̃MUMUɘa
              //̏ŁAׂ̐FȂ
              String s1 = st2.nextToken().trim();
              if(s1.equals("true"))
                canvas.antialiasFlag = true;
              else
                canvas.antialiasFlag = false;
            }
            else if(method.equals("Paper"))
            { //̑傫i~Ŏwj
                //Paper(double w, double h)
                //w:        p
                //h:        p
                String s = st2.nextToken().trim();
                if     (s.equals("\"A3\""))
                {  //p^͊ȈՎw\
                    canvas.paperW = 297;
                    canvas.paperH = 420;
                }
                else if(s.equals("\"B4\""))
                {
                    canvas.paperW = 257;
                    canvas.paperH = 364;
                }
                else if(s.equals("\"A4\""))
                {
                    canvas.paperW = 210;
                    canvas.paperH = 297;
                }
                else if(s.equals("\"B5\""))
                {
                    canvas.paperW = 182;
                    canvas.paperH = 257;
                }
                else if(s.equals("\"A5\""))
                {
                    canvas.paperW = 148;
                    canvas.paperH = 210;
                }
                else if(s.equals("\"B6\""))
                {
                    canvas.paperW = 128;
                    canvas.paperH = 182;
                }
                else if(s.equals("\"A6\""))
                {
                    canvas.paperW = 105;
                    canvas.paperH = 148;
                }
                else if(s.equals("\"PostCard\""))
                {
                    canvas.paperW = 100;
                    canvas.paperH = 148;
                }
                else
                {
                    canvas.paperW = Double.parseDouble(s);
                    canvas.paperH = Double.parseDouble(st2.nextToken().trim());
                }
            }
            else if(method.equals("FreeScale"))
            { //Cӂ̊g嗦̎wiɂfj
                //FreeScale(double scale)
                //scale:    \A摜ۑAɗLȊg{
                canvas.freeScale = Double.parseDouble(st2.nextToken().trim());
            }
            else if(method.equals("Margin"))
            { //]w
                //Margin(double top, double left)
                //top:      V]
                //left:     ]
                canvas.marginT = Double.parseDouble(st2.nextToken().trim());
                canvas.marginL = Double.parseDouble(st2.nextToken().trim());
            }
            else if(method.equals("Shift"))
            { //摜炷w
                //Shift(int mode, double x, double y)
                //mode:     0VtgȂ
                //          1Vtg
                //          2y[WVtg
                //x:        X̃Vtg
                //y:        ỸVtg
                canvas.shiftClass = Integer.parseInt(st2.nextToken().trim());
                canvas.shiftX = Double.parseDouble(st2.nextToken().trim());
                canvas.shiftY = Double.parseDouble(st2.nextToken().trim());
            }
            else if(method.equals("PageHeader"))
            { //y[Wo̍
                //PageHeader(double h)
                //h:        y[Wo̍
                canvas.pHeaderH = Double.parseDouble(st2.nextToken().trim());
            }
            else if(method.equals("TableHeader"))
            { //\gݘǧo̍
                //TableHeader(double h)
                //h:        \o̍
                canvas.tHeaderH = Double.parseDouble(st2.nextToken().trim());
            }
            else if(method.equals("Title"))
            { //\g݂̃^Cg
                //Title(String title)
                //title:    W蕶
                canvas.title = Util.trimAffix(st2.nextToken(),'\"','\"');
            }
            else if(method.equals("Subtitle"))
            { //\g݂̃Tu^Cg
                //Subtitle(String subtitle)
                //subtitle: 蕶
                canvas.subtitle = Util.trimAffix(st2.nextToken(),'\"','\"');
            }
            else if(method.equals("Number"))
            { //ނ̔Cӂ̔sԍi܂͔sNj
                //Number(String number)
                //number:   sԍ
                canvas.number = Util.trimAffix(st2.nextToken(),'\"','\"');
            }
            else if(method.equals("PageNumber"))
            { //ނ̃y[W\
                //PageNumber(bool pn)
                //pn:      y[Wԍ\邩ۂ
                String value = st2.nextToken().trim();
                if(value.equals("false"))
                    canvas.pageNumFlag = false;
                else
                    canvas.pageNumFlag = true;
            }
            else if(method.equals("FontSize"))
            { //TCYw
                //FontSize(int point)
                //point:    ̃|Cg
                canvas.fontSize = Integer.parseInt(st2.nextToken().trim());
            }
            else if(method.equals("FontBold"))
            { //w
                //FontBold(bool b)
                //b:        wȂtrue
                String value = st2.nextToken().trim();
                if(value.equals("true"))
                {
                    canvas.fontBold = true;
                }
                else if(value.equals("false"))
                {
                    canvas.fontBold = false;
                }
                else
                    throw new Exception(">>" + define);
            }
            else if(method.equals("Column"))
            { //r\̍s̎wiẻj
                //Column(double w, String constant, String header)
                //w:        ̕
                //constant: ʒu萔 (L/R/Nx)
                //header:   o
                canvas.columnList.add(define); //R}h͌̕
            }
            else if(method.equals("ColumnBlock")) 
            { //r\̗̃ubN
                //ColumnBlock(int ... separator)
                //    separator:c̓_̎w
                //0_A1ŁȂgŎw肷B
                //JԂ̋Eŵ߁A̓JPȂB
                StringTokenizer st3 = new StringTokenizer(define,"();");
                st3.nextToken(); //R}ĥ͎Ă
                String sep = st3.nextToken().trim(); //Q擾
                canvas.colBlockArr = Util.csv2Array(sep, 0);
            }
            else if(method.equals("Row"))
            { //r\̍s̎w
                //Row(double h, double rows)
                //h:        s̍
                //rows:     Py[W̍s
                canvas.cellH = Double.parseDouble(st2.nextToken().trim());
                canvas.rows  = Integer.parseInt(st2.nextToken().trim())-1;
            }
            else if(method.equals("RowBlock"))
            { //r\̍s̃ubNw
                //RowBlock(int b)
                //b:        s̃ubNw
                //Ⴆ΁A3w肷΁A_̉rQŝƁA
                //̉rPšJԂƂȂB
                canvas.rowBlock = Integer.parseInt(st2.nextToken().trim());
            }
            else if(method.equals("LineWidth"))
            { //̑w
                //LineWidth(float width)
                //width:    ̑
                canvas.lineWidth = Float.parseFloat(st2.nextToken().trim());
            }
            else if(method.equals("DrawLine"))
            { //̕`w
                //DrawLine(double x1, double y1, double x2, double y2)
                //x1:       N_WX
                //y1:       N_WY
                //x2:       I_WX
                //y2:       I_WY
                double[] d = new double[4];
                d[0] = Double.parseDouble(st2.nextToken().trim());
                d[1] = Double.parseDouble(st2.nextToken().trim());
                d[2] = Double.parseDouble(st2.nextToken().trim());
                d[3] = Double.parseDouble(st2.nextToken().trim());
                canvas.lineList.add(d);
            }
            else if(method.equals("WriteString") &&
               Util.countDelimiter(define, ',') == 4)
            { //̕`wiڍאݒj
                //WriteTitle(double x,double y,int size, 
                //          string style, string s)
                //x:        W
                //y:        W
                //size:     tHgETCY
                //style:    `i"sansserif" / "serif" / "monospaced"j
                //s:        \镶
                double[] d = new double[3];
                String[] s = new String[2];
                d[0] = Double.parseDouble(st2.nextToken().trim());
                d[1] = Double.parseDouble(st2.nextToken().trim());
                d[2] = Double.parseDouble(st2.nextToken().trim());
                s[0] = Util.trimAffix(st2.nextToken().trim(),'\"','\"');
                s[1] = Util.trimAffix(st2.nextToken().trim(),'\"','\"');
                canvas.freeStringListD.add(d);
                canvas.freeStringListS.add(s);
            }
            else if(method.equals("WriteString") &&
               Util.countDelimiter(define, ',') == 2)
            { //̕`wiȈՐݒj
                //WriteString(double x,double y,string s)
                //x:        W
                //y:        W
                //s:        \镶
                double[] d = new double[3];
                String[] s = new String[2];
                d[0] = Double.parseDouble(st2.nextToken().trim());
                d[1] = Double.parseDouble(st2.nextToken().trim());
                d[2] = canvas.fontSize;
                s[0] = "sansselif";
                s[1] = Util.trimAffix(st2.nextToken().trim(),'\"','\"');
                canvas.freeStringListD.add(d);
                canvas.freeStringListS.add(s);
            }
            else if(method.equals("Footnote"))
            { //r\̋r
                //Footnote(String s)
                //s:        r
                canvas.footnote = Util.trimAffix(st2.nextToken(),'\"','\"');
            }
            else if(method.equals("Footnote2"))
            { //r\̋r2s
                //Footnote2(String s)
                //s:        r
                canvas.footnote2 = Util.trimAffix(st2.nextToken(),'\"','\"');
            }
            else if(method.equals("DrawMode"))
            { //r\̌r̕`w
                //DrawMode(int mode)
                //   mode:     3ȂAȑcɕ`
                //             2ȂAr̉`
                //             1ȂAȑc`
                //             0ȂAr`悵Ȃ
                String value = st2.nextToken().trim();
                if(value==null)
                    throw new Exception("r\[hɖ肠");
                if(value.equals("3"))
                    canvas.drawMode = 3; //rcɕ`
                else if(value.equals("2"))
                    canvas.drawMode = 2; //r`
                else if(value.equals("1"))
                    canvas.drawMode = 1; //rc`
                else if(value.equals("0"))
                    canvas.drawMode = 0; //r`悵Ȃ
                else
                    throw new Exception("r\[hɖ肠");
            }
            else if(method.equals("LoadData"))
            { //f[^Et@C̎wif[^܂Ăꍇj
                //LoadData(String fileName)
                //FileName:     f[^Et@Cw
                //Ⴆ΁A"./data/filename.csv"
                canvas.loadData = Util.trimAffix(st2.nextToken(),'\"','\"');
            }
            else if(method.equals("SetData"))
            { //f[^̐ݒif[^܂Ăꍇj
                //SetData(String str)
                //str:          f[^w
                //Ⴆ΁A" " ̂悤ɋ󔒕_~[Ef[^Ƃ
                String str = Util.trimAffix(st2.nextToken(),'\"','\"');
                f.dArea.setText(str);
            }
            else if(method.equals("DataType"))
            { //f[^CSVTXT̎w
                //DataType(String s)
                //s:       "CSV"ȂACSVf[^iR}ł̋؂j
                //         "NUL"ȂAf[^Ȃ
                String value = Util.trimAffix(st2.nextToken(),'\"','\"');
                if(value.equals("CSV"))
                {
                    canvas.dataType = "CSV";
                    canvas.dataFlag = true;
                }
                else if(value.equals("NUL"))
                {
                    canvas.dataType = "NUL";
                    canvas.dataFlag = false;
                }
                else
                {
                    canvas.dataInspection = false;
                    throw new Exception("f[^E^Cvw肪ُ\n");
                }
            }
            else if(method.equals("Rotate"))
            { //摜90x]w
                //Rotate(bool b)
                //b:        true̎90x]
                String value = st2.nextToken().trim();
                if(value.equals("true"))
                    canvas.rotateFlag = true;
                else
                    canvas.rotateFlag = false;
            }
            else
            { //`ُ
                canvas.dataInspection = false;
                throw new Exception("\bhُF" + define);
        }
        } // foȑI
    
        //ColumnR}hQ̕
        method = "Column";
        Object[] objArr = canvas.columnList.toArray(); //Column(w,aline,header);
        if(objArr!=null)
            canvas.cols = objArr.length-1; //0NZ
        else
            canvas.cols = 0;
        canvas.colW = new double[canvas.cols+1];
        canvas.align = new String[canvas.cols+1];
        canvas.header = new String[canvas.cols+1];
        String columnCommands[] = new String[canvas.cols+1];
        for(int i=0; i<canvas.cols+1; i++)
            columnCommands[i] = (String)objArr[i];
        for(int i=0; i<canvas.cols+1; i++)
        {
            define = columnCommands[i];
            StringTokenizer st3 = new StringTokenizer(
                columnCommands[i],"(,)");  //
            st3.nextToken().trim(); //ColumnR}ĥ͎Ă
            canvas.colW[i] = Double.parseDouble(st3.nextToken().trim());
            String a = canvas.align[i] = Util.trimAffix(
                st3.nextToken().trim(),'\"','\"');
            canvas.header[i] = Util.trimAffix(st3.nextToken().trim(),'\"','\"');
            if(!(a.equals("L")||
                 a.equals("R")||
                (a.charAt(0)=='N' && a.length()==2 && '0'<=a.charAt(1) 
                    && '9'>=a.charAt(1)) ))
                // L:l
                // R:El
                // Nx:ɃR}tA_ȉxɊۂߏ
            {
                canvas.dataInspection = false;
                throw new Exception("Column̈Ɉُ");
            }
        }
    }
    catch(NumberFormatException e)
    {
        f.message("l\G[");
        f.message(">> "+define);
        canvas.methodErrorMessage(method + "(");
        canvas.dataInspection = false;
    }
    catch(Exception e)
    {
        f.message(e.toString());
        f.message(">> "+define + "R}h̓G[");
        canvas.methodErrorMessage(method + "(");
        canvas.dataInspection = false;
    }
  }
}
