//PrintCSV1PrintEngine.java

//C|[g
import java.awt.*;
import java.awt.geom.*;
import java.awt.print.*;
import javax.print.attribute.*;
import javax.print.attribute.standard.*;

//s
class PrintCSV1PrintEngine
{
    //o[ϐ
    PrintCSV1 f;
    double printerMarginX = 3.0; //Canon iP4500 p̒萔(mmP)
    double printerMarginY = 3.0; //Canon iP4500 p̒萔
    // A@ɂÂ߂̃v^[E}[W͈قȂB

    //RXgN4
    PrintCSV1PrintEngine(PrintCSV1 frame)
    {
        f = frame;
    }

    //Jnv̎t
    void start()
    {
        //fBXvC\{̕ۑ
        double scale = f.canvas.affineScale;

        //fBXvC\p̕`惍WbN`ɓ]p
        f.canvas.affineScale = 2.8457D; //Z{(1mm=2.8457point)
        //f.canvas.affineScale = 1*3*0.9483333D;  łOKBiR͉ʕ\{j

        //IuWFNg
        PrinterJob pj = PrinterJob.getPrinterJob();

        //pݒIuWFNg
        PageFormat fmt = new PageFormat();

        //pi[IuWFNg
        Paper paper = new Paper(); 

        //IuWFNgɗvݒ
        PrintOnePage printable = new PrintOnePage();

        if(f.canvas.rotateFlag == false)
        { //]Ȃ
            paper.setImageableArea(0,0,
                f.canvas.paperW*2.8457D,f.canvas.paperH*2.8457D);
        }
        else
        { //]
            paper.setImageableArea(0,0,
                f.canvas.paperH*2.8457D,f.canvas.paperW*2.8457D);
        }
        fmt.setPaper(paper);

        //]ݒ
        PrintRequestAttributeSet reqAtt = new HashPrintRequestAttributeSet();
        float topMgn    = 0.0f;  //]Ȃ
        float bottomMgn = 0.0f;
        float leftMgn   = 0.0f;
        float rightMgn  = 0.0f;
        if(f.canvas.rotateFlag == false) //]Ȃ
        {
            reqAtt.add(new MediaPrintableArea(
           leftMgn, topMgn,
           ((float)f.canvas.paperW - leftMgn - rightMgn),
           ((float)f.canvas.paperH - topMgn - bottomMgn), MediaPrintableArea.MM));
        }
        else //]
        {
            reqAtt.add(new MediaPrintableArea(
           leftMgn, topMgn,
           ((float)f.canvas.paperH - topMgn - bottomMgn),
           ((float)f.canvas.paperW - leftMgn - rightMgn), MediaPrintableArea.MM));
        }
        reqAtt.add(OrientationRequested.PORTRAIT);
        pj.setPrintable(new PrintOnePage());

        //Jn  
        try
        {  //Printable.print(...)Ƀy[Wɕ`v
            if (pj.printDialog()) //Jñ_CAOE{bNX
                pj.print(reqAtt); //Jn
        }
        catch(Exception e)
        {
            f.message("sG[F"+e);
        }

        //{fBXvC\pɖ߂
        f.canvas.affineScale = scale;
    }

    //cy[W
    boolean hasMorePages(int page)
    {
        if(f.canvas.pages < page)
            return false;
        else
            return true;
    }

    //C[W̕`i
    //PrinterJob̊Ǘŋ@\Printable̎
    class PrintOnePage implements Printable
    {
        public int print(Graphics g, PageFormat fmt,
            int pageIndex) //wy[W`
        { //wy[W`
            if(hasMorePages(pageIndex))
            { //y[W
                Graphics2D g2 = (Graphics2D)g;
                g2.translate(fmt.getImageableX()-printerMarginX*2.8457D,
                    fmt.getImageableY()-printerMarginY*2.8457D);
                //`͊Oϑ
                f.canvas.drawPage(g,true,pageIndex);
                //Yy[Ws}ԋp
                return Printable.PAGE_EXISTS;
            }
            else  
            { //ɂ~}ԋp
                return Printable.NO_SUCH_PAGE;
            }
        }
    }
}
